require 'anndb_api/image_dataset'
require 'anndb_api/text_dataset'
require 'anndb_api/vector_dataset'

module AnndbApi
    SERVER_ADDR = 'grpc-api.anndb.com:1433'

    class Client
        def initialize(api_key)
            @api_key = api_key
        end

        def images(dataset_name)
            AnndbApi::ImageDataset.new(AnndbApi::SERVER_ADDR, rpc_metadata_for_dataset(dataset_name))
        end

        def text(dataset_name)
            AnndbApi::TextDataset.new(AnndbApi::SERVER_ADDR, rpc_metadata_for_dataset(dataset_name))
        end

        def vector(dataset_name)
            AnndbApi::VectorDataset.new(AnndbApi::SERVER_ADDR, rpc_metadata_for_dataset(dataset_name))
        end

        private

        def rpc_metadata_for_dataset(dataset_name)
            { 'authorization': @api_key, 'dataset': dataset_name }
        end
    end
end